/*******************************************************************************
 *	@file			DLDebug.cpp
 *	@brief			DirectX Library
 *
 *	@date			29-May-2010(Sat)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DLDebug.h"

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// O[oϐ---------------------------------------------------------

// ֐vg^Cv錾---------------------------------------------------

// -----------------------------------------------------------------------------

/*******************************************************************************
 *	@fn				CDLDebug::CDLDebug( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLDebug::CDLDebug( void )
	: m_nMeterNum( 0 )
	, m_bMeterFlag( FALSE )
{
#ifdef _DEBUG
	Clear();
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				CDLGraph::~CDLGraph( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLDebug::~CDLDebug( void )
{
#ifdef _DEBUG
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				int CDLDebug::Init( const SDLDebug& SDbg )
 *	@param[in]		SDbg						fobO\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CDLDebug::Init( const SDLDebug& SDbg )
{
#ifdef _DEBUG
	m_bMeterFlag = ::QueryPerformanceFrequency( &m_lnBase );

#endif	// _DEBUG
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLDebug::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 ******************************************************************************/
int CDLDebug::End( void )
{
#ifdef _DEBUG
#endif	// _DEBUG
	return TRUE;
}

/*******************************************************************************
 *	@fn				void CDLDebug::Clear( void )
 *	@retval			none
 *	@brief			NA
 ******************************************************************************/
void CDLDebug::Clear( void )
{
#ifdef _DEBUG
	// v
	for( int i = 0; i < METER_MAX; i++ )
		m_lnMeter[ i ].QuadPart = 0;
	m_nMeterNum = 0;

#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				float CDLDebug::Measurement( void )
 *	@retval			float						fTime
 *	@brief			
 ******************************************************************************/
float CDLDebug::Measurement( void )
{
	float fTime = 0.0f;
#ifdef _DEBUG
	_ASSERT( m_nMeterNum < METER_MAX && "Measurement()" );
	// vJn
	if( m_lnMeter[ m_nMeterNum ].QuadPart == 0 )
	{
		::QueryPerformanceCounter( &m_lnMeter[ m_nMeterNum ] );
	}else
	// vI
	{
		LARGE_INTEGER lnTime;
		::QueryPerformanceCounter( &lnTime );

		fTime = static_cast<float>( ( ( lnTime.QuadPart - m_lnMeter[ m_nMeterNum ].QuadPart ) * 1000 ) / m_lnBase.QuadPart );
		m_nMeterNum++;
	}
#endif	// _DEBUG
	return fTime;
}

}	// namespace	DL
